/*
Copyright 2010-2011 Zhengmao HU (James)

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package net.sf.jabb.util.stat;

import java.util.Date;
import java.util.concurrent.TimeUnit;

/**
 * ƵμĻ࣬ʵһЩķʵַȥʵ֡
 * 
 * @author Zhengmao HU (James)
 *
 */
public abstract class FrequencyCounter {


	/**
	 * ¼ĳʱ̷˶ٴ
	 * @param when		ʱ
	 * @param times		Ĵ
	 */
	public abstract void count(long when, int times);

	/**
	 * ĳʱ̵ͳ
	 * @param when	ʱ
	 * @return		ͳ
	 */
	public abstract long getCount(long when);

	/**
	 * ĳʱڵͳ
	 * @param fromWhen		ʼʱ
	 * @param toWhen		ʱ
	 * @param fromInclusive	Ƿʼʱ
	 * @param toInclusive	Ƿʱ
	 * @return				ͳ
	 */
	public abstract long getCount(long fromWhen, long toWhen, boolean fromInclusive,
			boolean toInclusive);

	/**
	 * ɵʷ
	 * @param tillWhen	ĸʱΪֹ
	 */
	public abstract void purge(long tillWhen);

	/**
	 * ¼ĳʱ䷢˼
	 * @param when	ʱ
	 * @param times	
	 */
	public void count(Date when, int times) {
		count(when.getTime(), times);
	}

	/**
	 * ¼ĳʱ䷢һ
	 * @param when	ʱ
	 */
	public void count(long when) {
		count(when, 1);
	}
	
	/**
	 * ¼ڵǰʱ䷢һ
	 */
	public void count(){
		count(System.currentTimeMillis(), 1);
	}

	/**
	 * ¼ڵǰʱ䷢˼
	 * @param times	Ĵ
	 */
	public void count(int times){
		count(System.currentTimeMillis(), times);
	}

	/**
	 * ¼ĳʱ䷢һ
	 * @param when	ʱ
	 */
	public void count(Date when) {
		count(when.getTime(), 1);
	}

	/**
	 * ĳʱļ
	 * @param when	ʱ
	 * @return		ͳ
	 */
	public long getCount(Date when) {
		return getCount(when.getTime());
	}

	/**
	 * ĳʱļ
	 * @param fromWhen		ʼʱ
	 * @param toWhen		ʱ
	 * @return				ͳ
	 */
	public long getCount(long fromWhen, long toWhen) {
		return getCount(fromWhen, toWhen, true, false);
	}

	/**
	 * ĳʱļ
	 * @param fromWhen		ʼʱ
	 * @param toWhen		ʱ
	 * @param fromInclusive	Ƿʼʱ
	 * @param toInclusive	Ƿʱ
	 * @return				ͳ
	 */
	public long getCount(Date fromWhen, Date toWhen, boolean fromInclusive, boolean toInclusive) {
		return getCount(fromWhen.getTime(), toWhen.getTime(), true, false);
	}

	/**
	 * ĳʱļ
	 * @param fromWhen		ʼʱ
	 * @param toWhen		ʱ
	 * @return				ͳ
	 */
	public long getCount(Date fromWhen, Date toWhen) {
		return getCount(fromWhen.getTime(), toWhen.getTime(), true, false);
	}

	/**
	 * ĳʱļ
	 * @param toWhen	ĳʱΪֹ
	 * @param period	ǰƶʱ
	 * @param unit		ǰƶʱĵλ
	 * @return			ͳ
	 */
	public long getCount(long toWhen, long period, TimeUnit unit) {
		return getCount(toWhen - TimeUnit.MILLISECONDS.convert(period, unit), toWhen);
	}

	/**
	 * ĳʱļ
	 * @param toWhen	ĳʱΪֹ
	 * @param period	ǰƶʱ
	 * @param unit		ǰƶʱĵλ
	 * @return			ͳ
	 */
	public long getCount(Date toWhen, long period, TimeUnit unit) {
		return getCount(toWhen.getTime(), period, unit);
	}

	/**
	 * һʱļ
	 * @param period	ǰƶʱ
	 * @param unit		ǰƶʱĵλ
	 * @return			ͳ
	 */
	public long getCount(long period, TimeUnit unit) {
		return getCount(System.currentTimeMillis(), period, unit);
	}

	/**
	 * ɾһʱļ¼
	 * @param tillWhen	ĸʱΪֹ
	 */
	public void purge(Date tillWhen) {
		purge(tillWhen.getTime());
	}

	/**
	 * ɾһʱļ¼
	 * @param baseTime			ʲôʱ
	 * @param periodBefore		ʱ֮ǰҪɾ
	 * @param unit				ʱ䵥λ
	 */
	public void purge(long baseTime, long periodBefore, TimeUnit unit) {
		purge(baseTime - TimeUnit.MILLISECONDS.convert(periodBefore, unit));
	}

	/**
	 * ɾһʱļ¼
	 * @param baseTime		ʲôʱ
	 * @param periodBefore	ʱ֮ǰҪɾ
	 * @param unit			ʱ䵥λ
	 */
	public void purge(Date baseTime, long periodBefore, TimeUnit unit) {
		purge(baseTime.getTime(), periodBefore, unit);
	}

	/**
	 * ɾһʱļ¼
	 * @param periodBefore	𣬶ʱ֮ǰ
	 * @param unit			ʱ䵥λ
	 */
	public void purge(long periodBefore, TimeUnit unit) {
		purge(System.currentTimeMillis() - TimeUnit.MILLISECONDS.convert(periodBefore, unit));
	}

}